#include <vector>
#include <iostream>
#include <CL/sycl.hpp>

int main(){
//Sycl scope
    sycl::queue gpu_queue(sycl::gpu_selector{});
    sycl::queue cpu_queue(sycl::cpu_selector{});
    auto max_mem_alloc_gpu = gpu_queue.get_device().get_info<sycl::info::device::max_mem_alloc_size>();
    auto max_mem_alloc_cpu = cpu_queue.get_device().get_info<sycl::info::device::max_mem_alloc_size>();
    std::cout<<"Max Mem alloc GPU: "<<max_mem_alloc_gpu<<std::endl;
    std::cout<<"Max Mem alloc CPU: "<<max_mem_alloc_cpu<<std::endl;

    auto max_ints_cpu = (max_mem_alloc_cpu / sizeof(int));
    auto max_ints_gpu = (max_mem_alloc_gpu / sizeof(int));

    std::cout<<"Max ints GPU: "<<max_ints_gpu<<"\n";

    std::cout<<"Max ints CPU: "<<max_ints_cpu<<"\n";
    //max_ints=(int)max_ints*0.66;  DG1 MAx size =2.02
    //
//    float temp=max_ints/2;
 //   max_ints=max_ints*0.075;  IGPU Max size =3.99


    //max_ints=100;
    //std::cout<<"Max Integers: "<<max_ints<<std::endl;

    std::vector<int> max_vector_cpu(max_ints_cpu,1);
    std::vector<int> max_vector_gpu(max_ints_gpu,1);
    {
    sycl::buffer<int,1> vec_buffer_cpu(max_vector_cpu.data(),sycl::range<1>{max_ints_cpu});
    sycl::buffer<int,1> vec_buffer_gpu(max_vector_gpu.data(),sycl::range<1>{max_ints_gpu});
//    sycl::buffer<int,1> max_buff(sycl::range<1>{max_ints})
    gpu_queue.submit([&] (sycl::handler& cgh){
        auto myvec_acc=vec_buffer_gpu.get_access<sycl::access::mode::read_write>(cgh);
            cgh.parallel_for(sycl::range<1>{max_ints_gpu},[=] (sycl::id<1> i){
                myvec_acc[i]*=10;

            });
    });
        cpu_queue.submit([&] (sycl::handler& cgh){
        auto myvec_acc=vec_buffer_cpu.get_access<sycl::access::mode::read_write>(cgh);
            cgh.parallel_for(sycl::range<1>{max_ints_cpu},[=] (sycl::id<1> i){
                myvec_acc[i]*=10;

            });
    });
//gpu_queue.wait();
//std::cout<<max_vector[1]<<std::endl;
    }
std::vector<int> check_vec_cpu(max_ints_cpu,10);
std::vector<int> check_vec_gpu(max_ints_gpu,10);

check_vec_gpu==max_vector_gpu?std::cout<<"GPU max allocation Success\n":std::cout<<"GPU max allocation Failure\n";
check_vec_cpu==max_vector_cpu?std::cout<<"CPU max allocation Success\n":std::cout<<"CPU max allocation Failure\n";

//std::cout<<max_vector[1]<<std::endl;

return 0;

}
